#include <stdio.h>

#define MAXB 1200
#define SQR(A) ((A)*(A))

struct bod {
  int x, y;
};

int X, Y, M;
struct bod B[MAXB];
double bx, by, bd;

void read_b(int M)
{
  int i;

  for (i = 0; i < M; i++)
    scanf("%d %d", &B[i].x, &B[i].y);
}

void check_point(double x, double y)
{
  int i;
  double ad, md = 4e10;

  if (x < 0 || y < 0 || x > X || y > Y)
    return;
  for (i = 0; i < M; i++) {
    ad = SQR(B[i].x - x) + SQR(B[i].y - y);
    if (ad < md)
      md = ad;
  }
  if (md >= bd) {
    bd = md;
    bx = x; by = y;
  }
}

void tryone(struct bod X, struct bod Y, struct bod Z)
{
  double k;
  double nx, ny;

  k = ((double)((Z.x - Y.x) * (X.x - Z.x) - (Y.y - Z.y) * (X.y - Z.y))) / 2;
  k = k/((X.x - Y.x)*(X.y - Z.y) - (X.y - Y.y) * (X.x - Z.x));
  nx = ((double)(X.x + Y.x))/2 - k * (X.y-Y.y);
  ny = ((double)(X.y + Y.y))/2 + k * (X.x-Y.x);
  check_point(nx, ny);
}

void compute_three(void)
{
  int i, j, k;

  for (i = 0; i < M; i++)
    for (j = i+1; j < M; j++)
      for (k = j+1; k < M; k++)
        tryone(B[i], B[j], B[k]);
}

void tryedge(struct bod A, struct bod B)
{
  double k, nx, ny;

  k = ((((double)(A.x + B.x))/2) - X)/(A.y - B.y);
  nx = X; ny = (((double)(A.y + B.y))/2) + k*(A.x-B.x);
  check_point(nx, ny);
  k = (((double)(A.x + B.x))/2)/(A.y - B.y);
  nx = 0; ny = (((double)(A.y + B.y))/2) + k*(A.x-B.x);
  check_point(nx, ny);
  k = (Y - ((double)(A.y + B.y))/2)/(A.y - B.y);
  ny = Y; nx = (((double)(A.x + B.x))/2) - k*(A.y-B.y);
  check_point(nx, ny);
  k = (-((double)(A.y - B.y))/2)/(A.y - B.y);
  ny = 0; nx = (((double)(A.x + B.x))/2) - k*(A.y-B.y);
  check_point(nx, ny);
}

void compute_edge(void)
{
  int i, j;

  for (i = 0; i < M; i++)
    for (j = 0; j < M; j++)
      tryedge(B[i], B[j]);
}

int main(void)
{
  int K;

  scanf("%d", &K);
  while (K--) {
    scanf("%d %d %d", &X, &Y, &M);
    read_b(M);
    bd = 0;
    compute_three();
  /*  compute_edge();*/
    printf("The safest point is (%01f, %01f).\n", bx, by);
  }

  return 0;
}

